#pragma once

#include "ofMain.h"
#include "ofxOpenCv.h"            //Cabealho do OpenCV
#include "ofxCv.h"

using namespace ofxCv;
using namespace cv;

class ofApp : public ofBaseApp{

	public:
		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);

	// Camera:
		ofVideoGrabber cam; // Video Tracking source
		int camHeight;
		int camWidth;
		ofImage unwarped; // RAW image from camera
		
	// Descobridor de papel
		ofxCv::ContourFinder		contourFinder;	
		int 						thresholdCV;
		ofPolyline					contour;
		ofImage						warpedPaper;
		bool foundInfra;

		// ## Funo para retornar tipo de forma geomtrica
	private:
		string findForm(const ofPolyline &poly);
		template <class T>
		string findForm(const T &poly){
			return findForm(ofxCv::toOf(poly));
		}
};
